/*
    Control.cpp

    Implementation of the Control class.

    ---------------------------------------------------------------------------
 
    Copyright (C) 2016, Cornfield Electronics, Inc.
 
    This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 
    Unported License.
 
    To view a copy of this license, visit
    http://creativecommons.org/licenses/by-sa/3.0/
 
    Created by Bill Alessi & Mitch Altman.
 
   ---------------------------------------------------------------------------
*/

#include "Control.h"
#include "Console_.h"

void Control::charEv( char code )
{
   switch ( code )
   {
      case '<':                  // unmute object

         setMute( false );
         break;

      case '.':                  // mute object

         setMute( true );
         break;

      case '!':                  // reset object state

         reset();
         break;

      default:

         Mode::charEv( code );
   }
}

void Control::info()
{
   console.rtab();
   console.print( (char *)(mute ? ". " : "< ") );
}

void Control::reset()
{
   setMute( true );
}

void Control::setMute( boolean b )
{
   mute = b;
}

char Control::menu( key k )
{
   switch ( k.position() )
   {
      case 11: return '!';
      case 10: return '.';
      case  9: return '<';
      default: return 0;
   }
}

