/*
    Control.h  

    Declaration of the Control class.

    ---------------------------------------------------------------------------
 
    Copyright (C) 2016, Cornfield Electronics, Inc.
 
    This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 
    Unported License.
 
    To view a copy of this license, visit
    http://creativecommons.org/licenses/by-sa/3.0/
 
    Created by Bill Alessi & Mitch Altman.
 
   ---------------------------------------------------------------------------
*/

#ifndef CONTROL_H_INCLUDED
#define CONTROL_H_INCLUDED

#include "Mode.h"

class Control : public Mode
{
   private:

   boolean mute;                       // if true, object is "muted"

   public:

   virtual void  dynamics() {};        // perform a dynamic update
   virtual void  reset();              // reset object state

   inline boolean amMute()             // return mute status
   {
      return mute;
   }

   void    charEv( char );             // process a character event
   void    info();                     // display object info to console
   char    menu( key );                // map key event to character 
   void    setMute( boolean );         // mute-unmute object

} ;


#endif   // ifndef CONTROL_H_INCLUDED
